Imports System.Globalization
Imports System.ComponentModel
Imports System.Resources
Imports System.Threading

Public Class Form1
    ' Select English.
    Private Sub radEnglish_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radEnglish.CheckedChanged
        If Not radEnglish.Checked Then Exit Sub
        SetLocale("en-US")
        radEnglish.Checked = True ' Reloading resets this.
    End Sub

    ' Select German.
    Private Sub radGerman_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radGerman.CheckedChanged
        If Not radGerman.Checked Then Exit Sub
        SetLocale("de-DE")
        radGerman.Checked = True ' Reloading resets this.
    End Sub

    ' Reload the form using this locale.
    Private Sub SetLocale(ByVal locale_name As String)
        Static setting_locale As Boolean = False

        If setting_locale Then Exit Sub
        If Not Me.Created Then Exit Sub
        If Thread.CurrentThread.CurrentCulture.Name = locale_name Then Exit Sub

        setting_locale = True

        ' Make a CultureInfo.
        Dim culture_info As New CultureInfo(locale_name)

        ' Make the thread use this locale.
        Thread.CurrentThread.CurrentUICulture = culture_info
        Thread.CurrentThread.CurrentCulture = culture_info

        ' Reload the form.
        If Me.components IsNot Nothing Then Me.components.Dispose()
        Me.Controls.Clear()
        Me.InitializeComponent()

        setting_locale = False
    End Sub

    ' Display Help About.
    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click
#If True Then
        ' The easy way
        MessageBox.Show(My.Resources.RuntimeStrings.Help_About)
#Else
        ' This vesion explicitly uses a ResourceManager.
        ' The base name is <ProjectName>.<FileName>.
        Dim resource_manager As New ResourceManager("Localized.RuntimeStrings", Me.GetType.Assembly)

        ' Display the message.
        MessageBox.Show(resource_manager.GetString("Help_About"))
#End If
    End Sub

    ' Exit.
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub
End Class
