Public Class Form1
    Private Sub ValidateNonBlank(ByVal txt As TextBox, ByVal field_name As String)
        If txt.Text.Length = 0 Then
            errValidator.SetError(txt, _
                "The " & field_name & " must not be blank. " & _
                "Please enter a " & field_name & ".")
        Else
            errValidator.SetError(txt, Nothing)
        End If
    End Sub
    Private Sub ValidateExactLength(ByVal required_length As Integer, ByVal txt As TextBox, ByVal field_name As String)
        If txt.Text.Length <> required_length Then
            errValidator.SetError(txt, _
                "The " & field_name & " must have length " & _
                required_length.ToString() & ". " & _
                "Please enter a value with " & required_length.ToString() & _
                " characters for " & _
                field_name & ".")
        Else
            errValidator.SetError(txt, Nothing)
        End If
    End Sub
    Private Sub ValidateLike(ByVal pattern As String, ByVal txt As TextBox, ByVal field_name As String)
        If Not (txt.Text Like pattern) Then
            errValidator.SetError(txt, _
                "The " & field_name & " must have the format '" & _
                pattern & "'. " & _
                "Please enter a value for " & _
                field_name & " that has this format.")
        Else
            errValidator.SetError(txt, Nothing)
        End If
    End Sub

    Private Sub txtFirstName_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtFirstName.Validating
        ValidateNonBlank(txtFirstName, "first name")
    End Sub
    Private Sub txtLastName_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtLastName.Validating
        ValidateNonBlank(txtLastName, "last name")
    End Sub
    Private Sub txtStreet_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtStreet.Validating
        ValidateNonBlank(txtStreet, "street")
    End Sub
    Private Sub txtCity_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtCity.Validating
        ValidateNonBlank(txtCity, "city")
    End Sub
    Private Sub txtState_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtState.Validating
        ValidateExactLength(2, txtState, "state")
    End Sub
    Private Sub Zip_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtZip.Validating
        ValidateLike("#####", txtZip, "ZIP code")
    End Sub
    Private Sub PhoneH_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtPhoneH.Validating
        ValidateLike("###-###-####", txtPhoneH, "home phone number")
    End Sub
    Private Sub PhoneW_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtPhoneW.Validating
        ValidateLike("###-###-####", txtPhoneW, "work phone number")
    End Sub
    Private Sub PhoneCell_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtPhoneCell.Validating
        ValidateLike("###-###-####", txtPhoneCell, "cell phone number")
    End Sub
End Class
