Imports System.Collections.Generic


Public Class Parent
    Public Sub test()

    End Sub

End Class

Public Class Child
    Inherits Parent

End Class

Public Class Form1
    ' The collection of Shapes to draw.
    Private m_Shapes As New List(Of Shape)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim t As New Parent


        ' Make some Shapes.
        m_Shapes.Add(New RectangleShape(New Rectangle(50, 20, 50, 120), Color.Orange, Color.Red))
        m_Shapes.Add(New EllipseShape(New Rectangle(80, 60, 90, 180), Color.Blue, Color.DarkBlue))
        m_Shapes.Add(New RectangleShape(New Rectangle(20, 80, 210, 40), Color.Lime, Color.DarkGreen))
        m_Shapes.Add(New EllipseShape(New Rectangle(10, 150, 250, 50), Color.Pink, Color.Teal))

        ' Redraw.
        Me.Invalidate()
    End Sub

    ' Draw the shapes.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        For Each a_shape As Shape In m_Shapes
            a_shape.Draw(e.Graphics)
        Next a_shape
    End Sub
End Class

' The abstract Shape parent class.
Public MustInherit Class Shape
    Public Location As Rectangle
    Public FillColor As Color
    Public ForeColor As Color

    ' The constructor is protected so the child classes must
    ' provide constructors for the program to use.

    ' Save the location and colors.
    Public Sub New(ByVal shape_location As Rectangle, ByVal fill_color As Color, ByVal fore_color As Color)
        Location = shape_location
        FillColor = fill_color
        ForeColor = fore_color
    End Sub

    ' Methods.
    Public MustOverride Sub Draw(ByVal gr As Graphics)
End Class

' Derived Shape child classes.

' Rectangle.
Public Class RectangleShape
    Inherits Shape

    ' Constructor. Delegated to the Shape class.
    Public Sub New(ByVal shape_location As Rectangle, ByVal fill_color As Color, ByVal fore_color As Color)
        MyBase.New(shape_location, fill_color, fore_color)
    End Sub

    ' Draw the rectangle.
    Public Overrides Sub Draw(ByVal gr As System.Drawing.Graphics)
        Using the_brush As New SolidBrush(FillColor)
            gr.FillRectangle(the_brush, Location)
        End Using
        Using the_pen As New Pen(ForeColor)
            gr.DrawRectangle(the_pen, Location)
        End Using
    End Sub
End Class

' Ellipse.
Public Class EllipseShape
    Inherits Shape

    ' Constructor. Delegated to the Shape class.
    Public Sub New(ByVal shape_location As Rectangle, ByVal fill_color As Color, ByVal fore_color As Color)
        MyBase.New(shape_location, fill_color, fore_color)
    End Sub

    ' Draw the Ellipse.
    Public Overrides Sub Draw(ByVal gr As System.Drawing.Graphics)
        Using the_brush As New SolidBrush(FillColor)
            gr.FillEllipse(the_brush, Location)
        End Using
        Using the_pen As New Pen(ForeColor)
            gr.DrawEllipse(the_pen, Location)
        End Using
    End Sub
End Class
