Imports System.Math
Imports System.Collections.Generic

Public Class Form1
    Private m_NumberProcessor As New NumberProcessor

    ' Add events to the NumberProcessor.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckPrime
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckPower
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckEven
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckUnhandled

        m_NumberProcessor.Value = Integer.Parse(txtValue.Text)
    End Sub

    ' Set the new integer value.
    Private Sub txtValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtValue.TextChanged
        If IsNumeric(txtValue.Text) Then
            m_NumberProcessor.Value = Integer.Parse(txtValue.Text)
        End If
    End Sub

    Private Sub CheckPrime(ByVal value As Integer, ByRef was_handled As Boolean)
        If IsPrime(value) Then
            lblresult.Text = value.ToString() & " is prime"
            was_handled = True
        End If
    End Sub
    Private Function IsPrime(ByVal value As Integer) As Boolean
        If value < 0 Then value = -value
        If value <= 1 Then Return False
        If value = 2 Then Return True
        If value Mod 2 = 0 Then Return False
        For i As Integer = 3 To CInt(Sqrt(value)) Step 2
            If value Mod i = 0 Then Return False
        Next i
        Return True
    End Function

    Public Sub CheckPower(ByVal value As Integer, ByRef was_handled As Boolean)
        If IsPower(value) Then
            lblResult.Text = value.ToString() & " is a power"
            was_handled = True
        End If
    End Sub
    Private Function IsPower(ByVal value As Integer) As Boolean
        If value < 0 Then value = -value
        If value < 4 Then Return False
        For base As Integer = 2 To CInt(Sqrt(value))
            Dim power As Double = Log(value, base)
            If CInt(power) = power Then Return True
        Next base
        Return False
    End Function

    Public Sub CheckEven(ByVal value As Integer, ByRef was_handled As Boolean)
        If value Mod 2 = 0 Then
            lblResult.Text = value.ToString() & " is even"
            was_handled = True
        End If
    End Sub

    Public Sub CheckUnhandled(ByVal value As Integer, ByRef was_handled As Boolean)
        lblResult.Text = value.ToString() & " was not handled"
        was_handled = True
    End Sub
End Class

Public Class NumberProcessor
    Private m_Value As Integer
    Public Property Value() As Integer
        Get
            Return m_Value
        End Get
        Set(ByVal value As Integer)
            m_Value = value
            RaiseEvent NumberChanged(m_Value, False)
        End Set
    End Property

    Public Delegate Sub NumberChangedDelegate(ByVal value As Integer, ByRef was_handled As Boolean)
    Private m_EventDelegates As New List(Of NumberChangedDelegate)
    Public Custom Event NumberChanged As NumberChangedDelegate
        AddHandler(ByVal value As NumberChangedDelegate)
            m_EventDelegates.Add(value)
        End AddHandler

        RemoveHandler(ByVal value As NumberChangedDelegate)
            m_EventDelegates.Remove(value)
        End RemoveHandler

        RaiseEvent(ByVal value As Integer, ByRef was_handled As Boolean)
            was_handled = False
            For Each a_delegate As NumberChangedDelegate In m_EventDelegates
                a_delegate(value, was_handled)
                If was_handled Then Exit For
            Next a_delegate
        End RaiseEvent
    End Event
End Class
