Imports System.Math
Imports System.Collections.Generic

Public Class Form1
    Private m_NumberProcessor As New NumberProcessor

    ' Add events to the NumberProcessor.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckPrime
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckPower
        AddHandler m_NumberProcessor.NumberChanged, AddressOf CheckEven

        m_NumberProcessor.Value = Integer.Parse(txtValue.Text)
    End Sub

    ' Set the new integer value.
    Private Sub txtValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtValue.TextChanged
        If IsNumeric(txtValue.Text) Then
            m_NumberProcessor.Value = Integer.Parse(txtValue.Text)
        End If
    End Sub

    Private Sub CheckPrime(ByVal value As Integer)
        If IsPrime(value) Then
            lblPrime.Text = "Prime"
        Else
            lblPrime.Text = "Not prime"
        End If
    End Sub
    Private Function IsPrime(ByVal value As Integer) As Boolean
        If value < 0 Then value = -value
        If value <= 1 Then Return False
        If value = 2 Then Return True
        If value Mod 2 = 0 Then Return False
        For i As Integer = 3 To CInt(Sqrt(value)) Step 2
            If value Mod i = 0 Then Return False
        Next i
        Return True
    End Function

    Public Sub CheckPower(ByVal value As Integer)
        If IsPower(value) Then
            lblPower.Text = "A power"
        Else
            lblPower.Text = "Not a power"
        End If
    End Sub
    Private Function IsPower(ByVal value As Integer) As Boolean
        If value < 0 Then value = -value
        If value < 4 Then Return False
        For base As Integer = 2 To CInt(Sqrt(value))
            Dim power As Double = Log(value, base)
            If CInt(power) = power Then Return True
        Next base
        Return False
    End Function

    Public Sub CheckEven(ByVal value As Integer)
        If value Mod 2 = 0 Then
            lblEven.Text = "Even"
        Else
            lblEven.Text = "Not even"
        End If
    End Sub
End Class

Public Class NumberProcessor
    Private m_Value As Integer
    Public Property Value() As Integer
        Get
            Return m_Value
        End Get
        Set(ByVal value As Integer)
            m_Value = value
            RaiseEvent NumberChanged(m_Value)
        End Set
    End Property

    Public Delegate Sub NumberChangedDelegate(ByVal value As Integer)
    Public Event NumberChanged As NumberChangedDelegate
End Class
