Public Class Form1
    Private m_MotorHome As New MotorHome

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With m_MotorHome
            .NumberOfBedrooms = Integer.Parse(txtBedrooms.Text)
            .NumberOfBathrooms = Single.Parse(txtBathrooms.Text)
            .SquareFeet = Integer.Parse(txtSquareFeet.Text)
            .PricePerSquareFoot = Single.Parse(txtPricePerFoot.Text)
            lblValue.Text = .CalculateValue.ToString("C")

            .MilesPerGallon = Single.Parse(txtMilesPerGallon.Text)
            .FuelCapacity = Single.Parse(txtFuelCapacity.Text)
            .FuelRemaining = Single.Parse(txtFuelRemaining.Text)
            lblRange.Text = .CalculateRange().ToString()
        End With
    End Sub

    Private Sub UpdateValue(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSquareFeet.TextChanged, txtPricePerFoot.TextChanged
        lblValue.Text = m_MotorHome.CalculateValue.ToString("C")
    End Sub

    Private Sub UpdateRange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFuelRemaining.TextChanged, txtMilesPerGallon.TextChanged
        lblRange.Text = m_MotorHome.CalculateRange.ToString("0")
    End Sub
End Class

Public Class House
    Public NumberOfBedrooms As Integer
    Public NumberOfBathrooms As Single
    Public SquareFeet As Integer
    Public PricePerSquareFoot As Single

    ' Return estimated value.
    Public Function CalculateValue() As Single
        Return SquareFeet * PricePerSquareFoot
    End Function
End Class

Public Class Vehicle
    Public MilesPerGallon As Single
    Public FuelCapacity As Single
    Public FuelRemaining As Single

    ' Return estimated range.
    Public Function CalculateRange() As Single
        Return MilesPerGallon * FuelRemaining
    End Function
End Class

Public Class MotorHome
    Inherits House

    ' The Vehicle we delegate to.
    Private m_Vehicle As New Vehicle

    Public Property MilesPerGallon() As Single
        Get
            Return m_Vehicle.MilesPerGallon
        End Get
        Set(ByVal value As Single)
            m_Vehicle.MilesPerGallon = value
        End Set
    End Property

    Public Property FuelCapacity() As Single
        Get
            Return m_Vehicle.FuelCapacity
        End Get
        Set(ByVal value As Single)
            m_Vehicle.FuelCapacity = value
        End Set
    End Property

    Public Property FuelRemaining() As Single
        Get
            Return m_Vehicle.FuelRemaining
        End Get
        Set(ByVal value As Single)
            m_Vehicle.FuelRemaining = value
        End Set
    End Property

    ' Return estimated range.
    Public Function CalculateRange() As Single
        Return m_Vehicle.CalculateRange
    End Function
End Class