Public Class Form1
    Private m_Person As New Person

    ' Update the m_Person object.
    Private Sub txtFirstName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFirstName.TextChanged
        m_Person.FirstName = txtFirstName.Text
    End Sub
    Private Sub txtLastName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtLastName.TextChanged
        m_Person.LastName = txtLastName.Text
    End Sub
    Private Sub txtStreet_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtStreet.TextChanged
        m_Person.Street = txtStreet.Text
    End Sub
    Private Sub txtCity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCity.TextChanged
        m_Person.City = txtCity.Text
    End Sub
    Private Sub txtState_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtState.TextChanged
        m_Person.State = txtState.Text
    End Sub
    Private Sub txtZip_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtZip.TextChanged
        m_Person.Zip = txtZip.Text
    End Sub

    ' Save a snapshot.
    Private Sub btnTakeSnapshot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTakeSnapshot.Click
        lstSnapshots.Items.Add(m_Person.Snapshot)
    End Sub

    ' Restore a snapshot.
    Private Sub lstSnapshots_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSnapshots.SelectedIndexChanged
        m_Person.Snapshot = lstSnapshots.SelectedItem

        txtFirstName.Text = m_Person.FirstName
        txtLastName.Text = m_Person.LastName
        txtStreet.Text = m_Person.Street
        txtCity.Text = m_Person.City
        txtState.Text = m_Person.State
        txtZip.Text = m_Person.Zip
    End Sub
End Class

Public Class Person
    Public FirstName As String
    Public LastName As String
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String

    ' Save or restore a snapshot.
    Public Property Snapshot() As Object
        Get
            Dim person_snapshot As New PersonSnapshot
            person_snapshot.FirstName = FirstName
            person_snapshot.LastName = LastName
            person_snapshot.Street = Street
            person_snapshot.City = City
            person_snapshot.State = State
            person_snapshot.Zip = Zip
            Return person_snapshot
        End Get
        Set(ByVal value As Object)
            Dim person_snapshot As PersonSnapshot = DirectCast(value, PersonSnapshot)
            FirstName = person_snapshot.FirstName
            LastName = person_snapshot.LastName
            Street = person_snapshot.Street
            City = person_snapshot.City
            State = person_snapshot.State
            Zip = person_snapshot.Zip
        End Set
    End Property

    ' This class is visible only within the Person class.
    Private Class PersonSnapshot
        Public FirstName As String
        Public LastName As String
        Public Street As String
        Public City As String
        Public State As String
        Public Zip As String
    End Class
End Class