Imports System.Xml.Serialization
Imports System.IO

Public Class Form1
    Private m_Person As New Person

    ' Update the m_Person object.
    Private Sub txtFirstName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFirstName.TextChanged
        m_Person.FirstName = txtFirstName.Text
    End Sub
    Private Sub txtLastName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtLastName.TextChanged
        m_Person.LastName = txtLastName.Text
    End Sub
    Private Sub txtStreet_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtStreet.TextChanged
        m_Person.Street = txtStreet.Text
    End Sub
    Private Sub txtCity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCity.TextChanged
        m_Person.City = txtCity.Text
    End Sub
    Private Sub txtState_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtState.TextChanged
        m_Person.State = txtState.Text
    End Sub
    Private Sub txtZip_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtZip.TextChanged
        m_Person.Zip = txtZip.Text
    End Sub

    ' Save a snapshot.
    Private Sub btnTakeSnapshot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTakeSnapshot.Click
        lstSnapshots.Items.Add(New PersonSnapshot(m_Person))
    End Sub

    ' Restore a snapshot.
    Private Sub lstSnapshots_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSnapshots.SelectedIndexChanged
        Dim snapshot As PersonSnapshot = DirectCast(lstSnapshots.SelectedItem, PersonSnapshot)
        m_Person = snapshot.RecreatePerson()

        txtFirstName.Text = m_Person.FirstName
        txtLastName.Text = m_Person.LastName
        txtStreet.Text = m_Person.Street
        txtCity.Text = m_Person.City
        txtState.Text = m_Person.State
        txtZip.Text = m_Person.Zip
    End Sub
End Class

<Serializable()> _
Public Class Person
    Public FirstName As String
    Public LastName As String
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String
End Class

' This class is visible only within the Person class.
Public Class PersonSnapshot
    Private m_PersonSerialization As String

    ' Save the Person's serialization.
    Public Sub New(ByVal the_person As Person)
        Dim xml_serializer As New XmlSerializer(GetType(Person))
        Using string_writer As New StringWriter()
            xml_serializer.Serialize(string_writer, the_person)
            m_PersonSerialization = string_writer.ToString()
        End Using
    End Sub

    ' Return an object from this serialization.
    Public Function RecreatePerson() As Person
        Dim xml_serializer As New XmlSerializer(GetType(Person))
        Dim string_reader As New StringReader(m_PersonSerialization)
        Return DirectCast(xml_serializer.Deserialize(string_reader), Person)
    End Function
End Class
