Public Class Form1
    Dim m_People As New List(Of Person)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make some people.
        m_People.Add(New Person("Fran", "Banner"))
        m_People.Add(New Person("Abe", "Driver"))
        m_People.Add(New Person("Deena", "Eager"))
        m_People.Add(New Person("Chuck", "Camper"))
        m_People.Add(New Person("Ed", "Finkle"))
        m_People.Add(New Person("Bea", "Archer"))
        
        ShowPeople()
    End Sub

    ' Display the items in their current order.
    Private Sub ShowPeople()
        lstPeople.Items.Clear()
        For Each per As Person In m_People
            lstPeople.Items.Add(per.ToString())
        Next per
    End Sub

    ' Sort by first name/last name.
    Private Sub radFirstLast_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radFirstLast.CheckedChanged
        Dim sorter As New PersonSorterFirstLast()
        m_People.Sort(sorter)
        ShowPeople()
    End Sub

    ' Sort by last name/first name.
    Private Sub radLastFirst_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radLastFirst.CheckedChanged
        Dim sorter As New PersonSorterLastFirst()
        m_People.Sort(sorter)
        ShowPeople()
    End Sub
End Class

Public Class Person
    Public FirstName As String
    Public LastName As String

    Public Sub New(ByVal first_name As String, ByVal last_name As String)
        FirstName = first_name
        LastName = last_name
    End Sub

    Public Overrides Function ToString() As String
        Return FirstName & " " & LastName
    End Function
End Class

Public Class PersonSorterFirstLast
    Implements IComparer(Of Person)

    Public Function Compare(ByVal x As Person, ByVal y As Person) As Integer Implements System.Collections.Generic.IComparer(Of Person).Compare
        Dim x_name As String = x.FirstName & " " & x.LastName
        Dim y_name As String = y.FirstName & " " & y.LastName
        Return x_name.CompareTo(y_name)
    End Function
End Class

Public Class PersonSorterLastFirst
    Implements IComparer(Of Person)

    Public Function Compare(ByVal x As Person, ByVal y As Person) As Integer Implements System.Collections.Generic.IComparer(Of Person).Compare
        Dim x_name As String = x.LastName & " " & x.FirstName
        Dim y_name As String = y.LastName & " " & y.FirstName
        Return x_name.CompareTo(y_name)
    End Function
End Class