Public Class MotorHome
    ' Initialize the m_Vehicle and m_House objects.
    Public Sub New(ByVal miles_per_gallon As Single, ByVal fuel_capacity As Single, ByVal fuel_remaining As Single, ByVal number_of_bedrooms As Integer, ByVal number_of_bathrooms As Single, ByVal square_feet As Integer, ByVal price_per_square_foot As Single)
        m_Vehicle = New Vehicle(miles_per_gallon, fuel_capacity, fuel_remaining)
        m_House = New House(number_of_bedrooms, number_of_bathrooms, square_feet, price_per_square_foot)
    End Sub

#Region "Delegated to m_House"
    Private WithEvents m_House As House

    Friend Property NumberOfBedrooms() As Integer
        Get
            Return m_House.NumberOfBedrooms
        End Get
        Set(ByVal value As Integer)
            m_House.NumberOfBedrooms = value
        End Set
    End Property

    Friend Property NumberOfBathrooms() As Single
        Get
            Return m_House.NumberOfBathrooms
        End Get
        Set(ByVal value As Single)
            m_House.NumberOfBathrooms = value
        End Set
    End Property

    Friend Property SquareFeet() As Integer
        Get
            Return m_House.SquareFeet
        End Get
        Set(ByVal value As Integer)
            m_House.SquareFeet = value
        End Set
    End Property

    Friend Property PricePerSquareFoot() As Single
        Get
            Return m_House.PricePerSquareFoot
        End Get
        Set(ByVal value As Single)
            m_House.PricePerSquareFoot = value
        End Set
    End Property

    Friend Function CalculateValue() As Single
        Return m_House.CalculateValue()
    End Function

#End Region ' Delegated to m_House

#Region "Delegated to m_Vehicle"
    Private WithEvents m_Vehicle As Vehicle

    Public Property MilesPerGallon() As Single
        Get
            Return m_Vehicle.MilesPerGallon
        End Get
        Set(ByVal value As Single)
            m_Vehicle.MilesPerGallon = value
        End Set
    End Property

    Public Property FuelCapacity() As Single
        Get
            Return m_Vehicle.FuelCapacity
        End Get
        Set(ByVal value As Single)
            m_Vehicle.FuelCapacity = value
        End Set
    End Property

    Public Property FuelRemaining() As Single
        Get
            Return m_Vehicle.FuelRemaining
        End Get
        Set(ByVal value As Single)
            m_Vehicle.FuelRemaining = value
        End Set
    End Property

    Public ReadOnly Property CalculateRange() As Single
        Get
            Return m_Vehicle.CalculateRange
        End Get
    End Property

#End Region ' Delegated to m_Vehicle

End Class
