Imports System.ComponentModel

Public Class ContactConverter
    Inherits ExpandableObjectConverter

    ' We can convert from String.
    Public Overrides Function CanConvertFrom(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal sourceType As System.Type) As Boolean
        If sourceType Is GetType(String) Then Return True
        Return MyBase.CanConvertFrom(context, sourceType)
    End Function

    ' Convert from String.
    Public Overrides Function ConvertFrom(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal culture As System.Globalization.CultureInfo, ByVal value As Object) As Object
        If TypeOf (value) Is String Then
            Try
                Dim new_contact As New Contact
                Dim txt As String = DirectCast(value, String)
                Dim name_phone() As String = txt.Split(New Char() {"("c, ")"c})
                new_contact.Phone = name_phone(1).Trim
                Dim first_last() As String = name_phone(0).Split(","c)
                new_contact.FirstName = first_last(0).Trim()
                new_contact.LastName = first_last(1).Trim()
                Return new_contact
            Catch ex As Exception
                Throw New ArgumentException("Error converting '" & _
                    CStr(value) & "' into a Contact object")
            End Try
        Else
            Return MyBase.ConvertFrom(context, culture, value)
        End If
    End Function

    ' We can convert into String.
    Public Overrides Function CanConvertTo(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal destinationType As System.Type) As Boolean
        If destinationType Is GetType(String) Then Return True
        Return MyBase.CanConvertTo(context, destinationType)
    End Function

    ' Convert into a String.
    Public Overrides Function ConvertTo(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal culture As System.Globalization.CultureInfo, ByVal value As Object, ByVal destinationType As System.Type) As Object
        If (destinationType Is GetType(String)) AndAlso _
           (TypeOf value Is Contact) _
        Then
            Dim the_contact As Contact = DirectCast(value, Contact)
            Return the_contact.FirstName & ", " & _
                the_contact.LastName & " (" & _
                the_contact.Phone & ")"
        Else
            Return MyBase.ConvertTo(context, culture, value, destinationType)
        End If
    End Function
End Class
