Imports System.Drawing.Design
Imports System.ComponentModel

<ToolboxBitmap(GetType(FaceControl), "tbxFaceControl")> _
Public Class FaceControl
    ' The face state enum.
    Public Enum FaceStates
        Happy
        Neutral
        Sad
        Painful
    End Enum
    Private m_FaceState As FaceStates = FaceStates.Neutral
    <EditorAttribute(GetType(FaceControlEditor), GetType(UITypeEditor))> _
    Public Property FaceState() As FaceStates
        Get
            Return m_FaceState
        End Get
        Set(ByVal value As FaceStates)
            m_FaceState = value
            Me.Invalidate()
        End Set
    End Property

    ' Display the appropriate image.
    Private Sub FaceControl_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Select Case FaceState
            Case FaceStates.Happy
                e.Graphics.DrawImage(My.Resources.good_face, 0, 0)
            Case FaceStates.Neutral
                e.Graphics.DrawImage(My.Resources.neutral_face, 0, 0)
            Case FaceStates.Sad
                e.Graphics.DrawImage(My.Resources.bad_face, 0, 0)
            Case FaceStates.Painful
                e.Graphics.DrawImage(My.Resources.pain_face, 0, 0)
        End Select
    End Sub
End Class
