' Requires a reference to:
'   System.Runtime.Serialization.Formatters.Soap.dll

Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Soap
Imports System.IO

Public Class Form1
    Private Sub btnSerializeDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerializeDeserialize.Click
        Dim per As New Person("Rod", "Stephens", "444-5555", "12 Street St")

        Debug.WriteLine(vbCrLf & vbCrLf & "***** Original Object *****")
        Debug.WriteLine(per.ToString() & vbCrLf)

        ' Serialize.
        Dim soap_formatter As New SoapFormatter()
        Dim memory_stream As New MemoryStream()
        soap_formatter.Serialize(memory_stream, per)
        memory_stream.Seek(0, SeekOrigin.Begin)
        Dim stream_reader As New StreamReader(memory_stream)
        Dim txt As String = stream_reader.ReadToEnd()
        Debug.WriteLine("***** Serialization *****")
        Debug.WriteLine(txt & vbCrLf)

        Debug.WriteLine("***** After Serialization *****")
        Debug.WriteLine(per.ToString() & vbCrLf)

        ' Deserialize.
        memory_stream.Seek(0, SeekOrigin.Begin)
        Dim per2 As Person = DirectCast(soap_formatter.Deserialize(memory_stream), Person)
        Debug.WriteLine("***** After Deserialization *****")
        Debug.WriteLine(per2.ToString() & vbCrLf)

        ' Remove the Street field from the serialization.
        Dim pos1 As Integer = txt.IndexOf("<Phone")
        Dim pos2 As Integer = txt.IndexOf("</Phone>")
        txt = txt.Substring(0, pos1 - 1) & txt.Substring(pos2 + 8)
        memory_stream = New MemoryStream()
        Dim stream_writer As New StreamWriter(memory_stream)
        stream_writer.Write(txt)
        stream_writer.Flush()

        ' Deserialize.
        memory_stream.Seek(0, SeekOrigin.Begin)
        Dim per3 As Person = DirectCast(soap_formatter.Deserialize(memory_stream), Person)
        Debug.WriteLine("***** After Deserialization w/o Phone *****")
        Debug.WriteLine(per3.ToString() & vbCrLf)
    End Sub
End Class

<Serializable()> _
Public Class Person
    Public FirstName As String
    Public LastName As String
    <OptionalField()> _
    Public Phone As String
    Public Street As String

    Public Sub New()
    End Sub
    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Phone As String, ByVal new_Street As String)
        FirstName = new_FirstName
        LastName = new_LastName
        Phone = new_Phone
        Street = new_Street
    End Sub

    Public Overrides Function ToString() As String
        Return FirstName & ", " & LastName & ", " & Phone & ", " & Street
    End Function

    <OnSerializing()> _
    Friend Sub OnSerializingMethod(ByVal context As StreamingContext)
        FirstName = "OnSerializingMethod"
    End Sub

    <OnSerialized()> _
    Friend Sub OnSerializedMethod(ByVal context As StreamingContext)
        LastName = "OnSerializedMethod"
    End Sub

    <OnDeserializing()> _
    Friend Sub OnDeserializingMethod(ByVal context As StreamingContext)
        Phone = "OnDeserializingMethod"
    End Sub

    <OnDeserialized()> _
    Friend Sub OnDeserializedMethod(ByVal context As StreamingContext)
        Street = "OnDeserializedMethod"
    End Sub
End Class