' This "editor" displays an About dialog.
' Requires a reference to System.Windows.Forms.Design.
Imports System.Drawing.Design

Public Class AboutEditor
    Inherits System.Drawing.Design.UITypeEditor

#Region "Value Editing Code"
    ' Indicates that this editor displays a modal dialog.
    Public Overloads Overrides Function GetEditStyle(ByVal context As System.ComponentModel.ITypeDescriptorContext) As System.Drawing.Design.UITypeEditorEditStyle
        Return UITypeEditorEditStyle.Modal
    End Function

    ' Display the dialog.
    Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
        ' Get an IWindowsFormsEditorService.
        Dim editor_service As IWindowsFormsEditorService = _
            CType(provider.GetService(GetType(IWindowsFormsEditorService)), _
                IWindowsFormsEditorService)

        ' If we failed to get the editor service, return the value unchanged.
        If editor_service Is Nothing Then Return value

        ' Make the editing dialog.
        Dim editor_dialog As New dlgAbout()

        ' Display the editing dialog.
        editor_service.ShowDialog(editor_dialog)

        ' Return the original data.
        Return value
    End Function
#End Region ' Value Editing Code

End Class
