Imports System.Drawing.Design
Imports System.ComponentModel

'<PropertyTabAttribute(GetType(TypeTab), PropertyTabScope.Document)> _
<DefaultProperty("DrawingFlags")> _
<DefaultEvent("ADefaultEvent")> _
<PropertyTabAttribute(GetType(TestPropertiesTab), PropertyTabScope.Document)> _
<Docking(DockingBehavior.AutoDock)> _
<ToolboxBitmap(GetType(UserControl1), "tbxUserControl1")> _
Public Class UserControl1
    Public Event ABrowsableEvent()

    <Browsable(False)> _
    Public Event ANonBrowsableEvent()

    Public Event ADefaultEvent()

    Private m_FirstName As String = ""
    <Category("Name Values")> _
    <Description("The employee's first or given name.")> _
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    Private m_LastName As String = ""
    <Category("Name Values")> _
    <Description("The employee's last or family name.")> _
    Public Property LastName() As String
        Get
            Return m_LastName
        End Get
        Set(ByVal value As String)
            m_LastName = value
        End Set
    End Property

    Private m_CurrentPrice As Single = 0
    <Category("Test Properties")> _
    <Browsable(False)> _
    Public Property CurrentPrice() As Single
        Get
            Return m_CurrentPrice
        End Get
        Set(ByVal value As Single)
            m_CurrentPrice = value
        End Set
    End Property

    Private m_OutsideTemperature As Single = 70
    <Category("Test Properties")> _
    <[ReadOnly](True)> _
    <Description("The current outside temperature. This property is read-only in the Properties window")> _
    Public Property OutsideTemperature() As Single
        Get
            Return m_OutsideTemperature
        End Get
        Set(ByVal value As Single)
            m_OutsideTemperature = value
        End Set
    End Property

    Private m_StatusImage As Image = Nothing
    ' The following don't seem to work.
    '<DefaultValue(GetType(Image), "UseAttributes.My.Resources.Resources.TypeTab")> _
    '<DefaultValue(GetType(Bitmap), "C:\One-on-One VB 2005\Src\Ch12\UseAttributes\Resources.TypeTab.bmp")> _
    '<DefaultValue(GetType(Image), "My.Resources.TypeTab")> _
    <DefaultValue(GetType(Image), Nothing)> _
    <Category("Test Properties")> _
    Public Property StatusImage() As Image
        Get
            Return m_StatusImage
        End Get
        Set(ByVal value As Image)
            m_StatusImage = value
        End Set
    End Property

    Private m_StatusSingle As Single = 0
    <Category("Test Properties")> _
    <DefaultValue(0)> _
    Public Property StatusSingle() As Single
        Get
            Return m_StatusSingle
        End Get
        Set(ByVal value As Single)
            m_StatusSingle = value
        End Set
    End Property

    Private Const DEFAULT_TITLE As String = "Untitled"
    Private m_Title As String = DEFAULT_TITLE
    <Category("Test Properties")> _
    <DefaultValue(DEFAULT_TITLE)> _
    Public Property Title() As String
        Get
            Return m_Title
        End Get
        Set(ByVal value As String)
            m_Title = value
        End Set
    End Property

    Private m_TheDefaultProperty As String = "The default property"
    <Category("Test Properties")> _
    Public Property TheDefaultProperty() As String
        Get
            Return m_TheDefaultProperty
        End Get
        Set(ByVal value As String)
            m_TheDefaultProperty = value
        End Set
    End Property

    Private m_ReportLanguage As String = "English"
    <Category("Test Properties")> _
    <Localizable(True)> _
    Public Property ReportLanguage() As String
        Get
            Return m_ReportLanguage
        End Get
        Set(ByVal value As String)
            m_ReportLanguage = value
        End Set
    End Property

    Private m_DesignOnlyProperty As String = "Design only property"
    <Category("Test Properties")> _
    <DesignOnly(True)> _
    Public Property DesignOnlyProperty() As String
        Get
            Return m_DesignOnlyProperty
        End Get
        Set(ByVal value As String)
            m_DesignOnlyProperty = value
        End Set
    End Property

    Private m_BoxColor As Color = Nothing
    <Category("Test Properties")> _
    <AmbientValue(GetType(Color), Nothing)> _
    <DefaultValue(GetType(Color), Nothing)> _
    Public Property BoxColor() As Color
        Get
            If (m_BoxColor = Nothing) AndAlso (Me.Parent IsNot Nothing) Then
                Return Me.Parent.ForeColor
            Else
                Return m_BoxColor
            End If
        End Get
        Set(ByVal value As Color)
            m_BoxColor = value
        End Set
    End Property

    Private Sub UserControl1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Const LINE_WID As Integer = 4
        Dim rect As New Rectangle(LINE_WID \ 2, LINE_WID \ 2, _
            Me.ClientSize.Width - LINE_WID, _
            Me.ClientSize.Height - LINE_WID)
        Using box_pen As New Pen(Me.BoxColor, LINE_WID)
            If (DrawingFlags And DrawingFlagValues.Box) <> DrawingFlagValues.None Then
                e.Graphics.DrawRectangle(box_pen, rect)
            End If
            If (DrawingFlags And DrawingFlagValues.X) <> DrawingFlagValues.None Then
                e.Graphics.DrawLine(box_pen, 0, 0, Me.ClientSize.Width - 1, Me.ClientSize.Height - 1)
                e.Graphics.DrawLine(box_pen, Me.ClientSize.Width - 1, 0, 0, Me.ClientSize.Height - 1)
            End If
            If (DrawingFlags And DrawingFlagValues.Cross) <> DrawingFlagValues.None Then
                e.Graphics.DrawLine(box_pen, 0, Me.ClientSize.Height \ 2, Me.ClientSize.Width - 1, Me.ClientSize.Height \ 2)
                e.Graphics.DrawLine(box_pen, Me.ClientSize.Width \ 2, 0, Me.ClientSize.Width \ 2, Me.ClientSize.Height - 1)
            End If
        End Using
    End Sub

    Private m_RuntimeUser As Person = New Person
    <Category("Test Properties")> _
    <DisplayName("Customer")> _
    <EditorBrowsable(EditorBrowsableState.Advanced)> _
    Public Property RuntimeUser() As Person
        Get
            Return m_RuntimeUser
        End Get
        Set(ByVal value As Person)
            m_RuntimeUser = value
        End Set
    End Property

    Private m_DatabasePassword As String = "ThePassword"
    <Category("Test Properties")> _
    <PasswordPropertyText(True)> _
    Public Property DatabasePassword() As String
        Get
            Return m_DatabasePassword
        End Get
        Set(ByVal value As String)
            m_DatabasePassword = value
        End Set
    End Property

    <Flags()> _
    Public Enum DrawingFlagValues
        None = 0
        Box = 1
        X = 2
        Cross = 4
        Spider = X Or Cross
    End Enum
    Private m_DrawingFlags As DrawingFlagValues = DrawingFlagValues.Box
    <Category("Test Properties")> _
    Public Property DrawingFlags() As DrawingFlagValues
        Get
            Return m_DrawingFlags
        End Get
        Set(ByVal value As DrawingFlagValues)
            m_DrawingFlags = value
            Me.Invalidate()
        End Set
    End Property

    ' A dummy property to display an About dialog.
    <Category("Test Properties")> _
    <ParenthesizePropertyName(True)> _
    <Editor(GetType(AboutEditor), GetType(UITypeEditor))> _
    Public Property About() As String
        Get
            Return Nothing
        End Get
        Set(ByVal value As String)
        End Set
    End Property

    Private m_XXX As String = "XXX"
    <Category("Test Properties")> _
    Public Property XXX() As String
        Get
            Return m_XXX
        End Get
        Set(ByVal value As String)
            m_XXX = value
        End Set
    End Property
End Class

<DesignTimeVisible(False)> _
Public Class Person
    Private m_Name As String = "Name"
    <Category("Test Properties")> _
    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(ByVal value As String)
            m_Name = value
        End Set
    End Property

    Private m_Address As String = "Address"
    <Category("Test Properties")> _
    Public Property Address() As String
        Get
            Return m_Address
        End Get
        Set(ByVal value As String)
            m_Address = value
        End Set
    End Property
End Class

Public Class ToolInToolbox
    Inherits Component

End Class

<ToolboxItem(False)> _
Public Class ToolNotInToolbox
    Inherits Component

End Class
