Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim per As New Person()
        ' per.ShowMesssage("test")

        Dim values() As Double = {10, 20, 30}
        Dim weights() As Double = {1, 1, 2}
        Debug.WriteLine(WeightedAverage(values, weights).ToString())

        Debug.WriteLine(AverageOrMid(New Integer() {13}))
        Debug.WriteLine(AverageOrMid(New Integer() {10, 20}))
        Debug.WriteLine(AverageOrMid(New Integer() {10, 20, 30}))
        Debug.WriteLine(AverageOrMid(New Integer() {10, 20, 21, 22, 23}))

        Dim qt As New Quadtree(Of MapLocation)
        Dim mp As New MapLocation
    End Sub

    ''' <summary>
    ''' Returns the weighted average of a series of values.
    ''' </summary>
    ''' <param name="values">The values to average.</param>
    ''' <param name="weights">The weights of the values.</param>
    ''' <returns>Sum(value(i) * weight(i))/Sum(weight(j)</returns>
    ''' <remarks>
    ''' The values and weights arrays must contain the same number of elements.
    ''' The total of the weights must be non-zero.
    ''' </remarks>
    ''' <exception cref="DivideByZeroException">Thrown if the total of the weights equals 0.</exception>
    ''' <exception cref="ArgumentException">Thrown if the number of values is different from the number of weights.</exception>
    Private Function WeightedAverage(ByVal values() As Double, ByVal weights() As Double) As Double
        ' Check inputs.
        If (values Is Nothing) Then Throw New ArgumentException("The values parameter is Nothing", "values")
        If (weights Is Nothing) Then Throw New ArgumentException("The weights parameter is Nothing", "weights")
        If (values.Length <> weights.Length) Then Throw New ArgumentException("The values and weights parameters must contain the same number of elements", "values, weights")

        ' Calculate the total weighted values and weights.
        Dim total_value As Double = 0
        Dim total_weight As Double = 0
        For i As Integer = 0 To values.Length - 1
            total_value += values(i) * weights(i)
            total_weight += weights(i)
        Next i

        Return total_value / total_weight
    End Function

    ''' <include file="external_comments.xml" 
    ''' path="FormTags/Sub[@name='SayHi']/*"></include>
    Private Sub SayHi()
        MessageBox.Show("Hi")
    End Sub

    ''' <include file="external_comments.xml" 
    ''' path="FormTags/Sub[@name='SayHello']/*"></include>
    Private Sub SayHello()
        MessageBox.Show("Hello")
    End Sub

    ''' <summary>
    ''' <para>This isn't a particularly useful routine.</para>
    ''' <para>It just demonstrates some XML comments.</para>
    ''' </summary>
    ''' <remarks>
    ''' <para>Here's what the routine does:</para>
    ''' <list type="table">
    '''   <listheader>
    '''     <term># Inputs</term>
    '''     <description>Result</description>
    '''   </listheader>
    '''   <item>
    '''     <term>1</term>
    '''     <description>The input</description>
    '''   </item>
    '''   <item>
    '''     <term>2</term>
    '''     <description>The average of the inputs</description>
    '''   </item>
    '''   <item>
    '''     <term>> 2</term>
    '''     <description>The middle value</description>
    '''   </item>
    ''' </list>
    ''' </remarks>
    Public Function AverageOrMid(ByVal ParamArray values() As Integer) As Single
        If values.Length = 1 Then
            Return values(0)
        ElseIf values.Length = 2 Then
            Return CSng(values(0) + values(1)) / 2
        Else
            Dim new_values(0 To values.Length - 1) As Integer
            values.CopyTo(new_values, 0)
            Array.Sort(new_values)
            Return new_values(values.Length \ 2)
        End If
    End Function

    Public Function NetworkAvailable() As Boolean

    End Function

    Public Enum DisplayTypes
        MessageBox
        OutputWindow
        LogFile
        Email
    End Enum

    ''' <summary>
    ''' Display a message in the indicated manner. 
    ''' Return True if successful, False otherwise.
    ''' <seealso cref="NetworkAvailable"/>
    ''' </summary>
    ''' <param name="msg">The message to display.</param>
    ''' <param name="display_type">The display medium.</param>
    ''' <returns>True if successful, False otherwise.</returns>
    ''' <remarks>
    ''' The program should not use Email if the computer has no network connection. 
    ''' Use <see cref="NetworkAvailable"/> to see if the network is available.
    ''' </remarks>
    Public Function DisplayMessage(ByVal msg As String, ByVal display_type As DisplayTypes) As Boolean

    End Function
End Class

' An object that has a Position property.
Public Interface IHasPosition
    ''' <value>The object's (X, Y) location.</value>
    Property Position() As Point
End Interface

''' <summary>
''' A quadtree node to store geographic data.
''' </summary>
''' <typeparam name="T">
''' The data that should be stored in the quadtree.
''' Must implement IHasPosition.
''' </typeparam>
''' <remarks></remarks>
Public Class Quadtree(Of T As IHasPosition)

End Class

Public Class MapLocation
    Implements IHasPosition

    ''' <value>The object's (X, Y) location.</value>
    Public Property Position() As System.Drawing.Point Implements IHasPosition.Position
        Get

        End Get
        Set(ByVal value As System.Drawing.Point)

        End Set
    End Property
End Class