''' <summary>
''' Represents a customer or employee.
''' </summary>
''' <remarks>Use a Manager object for managers.</remarks>
Public Class Person
    Private m_FirstName As String
    ''' <summary>
    ''' Returns the Person's first name.
    ''' </summary>
    ''' <value>The Person's first (given) name.</value>
    ''' <returns>The Person's first name string.</returns>
    ''' <remarks>The value is stored in the private m_FirstName variable.</remarks>
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    ''' <summary>
    ''' Displays a message.
    ''' </summary>
    ''' <param name="msg">The message to dsplay.</param>
    ''' <returns>The result of the call to MessageBox.Show.</returns>
    ''' <remarks>Simply calls MessageBox.Show.</remarks>
    Public Function ShowMesssage(ByVal msg As String) As DialogResult
        Return MessageBox.Show(msg)
    End Function

    ''' <summary>
    ''' Create a new Person with default property values.
    ''' </summary>
    ''' <remarks><c>FirstName</c> = "".</remarks>
    Public Sub New()
    End Sub

    ''' <summary>
    ''' Create a new Person with indicated property values.
    ''' </summary>
    ''' <param name="new_FirstName">The new Person's FirstName value.</param>
    ''' <remarks>Initializes the Person's properties using the parameters.</remarks>
    Public Sub New(ByVal new_FirstName As String)
        m_FirstName = new_FirstName
    End Sub

    ''' <summary>
    ''' Print a letter and envelope for this person.
    ''' </summary>
    ''' <param name="letter_text">The text of the letter to be printed.</param>
    ''' <param name="priority">The letter's priority. 1 = Highest.</param>
    ''' <remarks>Use this routine to generate a letter for a person.
    ''' The routine prints the letter on the default printer and
    ''' then waits for you to load an envelope in the manual feed before
    ''' addressing the envelope.</remarks>
    Public Sub PrintLetter(ByVal letter_text As String, ByVal priority As Integer, ByVal address As String)
        Dim lq As LetterQualities = LetterQualities.High

    End Sub

    ''' <summary>
    ''' Defines allowed letter qualities. The actual quality may depend on the printer.
    ''' For example, a fast printer may provide high-quality results even if
    ''' you select the <c>Low</c> setting.
    ''' </summary>
    Public Enum LetterQualities
        ''' <summary>
        ''' Use the lowest possible letter quality. Suitable only for drafts.
        ''' </summary>
        Low

        ''' <summary>
        ''' Use a medium-level qualify suitable only for working copies.
        ''' </summary>
        Medium

        ''' <summary>
        ''' Use the highest quality possible. Suitable for giving to customers
        ''' or producing final documentation.
        ''' </summary>
        High

        ''' <summary>
        ''' Use the default quality, usually <c>Medium</c>.
        ''' </summary>
        Normal
    End Enum
End Class
