Imports System.Math

Public Class Form1
    Private m_Drawing As Boolean = False
    Private m_LastPoint As Point = Nothing

    ' Start drawing.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        m_Drawing = True
        m_LastPoint = New Point(e.X, e.Y)
        Dim gr As Graphics = Me.CreateGraphics()
        gr.Clear(Me.BackColor)
    End Sub

    ' Continue drawing.
    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If Not m_Drawing Then Exit Sub
        Dim gr As Graphics = Me.CreateGraphics()
        gr.DrawLine(Pens.Blue, m_LastPoint, New Point(e.X, e.Y))
        m_LastPoint = New Point(e.X, e.Y)
    End Sub

    ' Stop drawing.
    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        m_Drawing = False
    End Sub

    ' Simulate manual drawing by using mouse_event.
    Private Sub btnSimulatedDraw_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimulatedDraw.Click
        Dim cx As Integer = Me.ClientSize.Width \ 2
        Dim cy As Integer = Me.ClientSize.Height \ 2
        Dim radius As Integer = Math.Min(Me.ClientSize.Width, Me.ClientSize.Height) \ 3

        ' MouseDown.
        Dim down_args As New MouseEventArgs( _
            Windows.Forms.MouseButtons.Left, _
            0, _
            CInt(cx + radius * Cos(0)), _
            CInt(cy + radius * Sin(0)), _
            0)
        Me.OnMouseDown(down_args)

        ' Move the mouse around in a randomized circle.
        Dim rnd As New Random
        For angle As Double = PI / 10 To 6 * PI Step PI / 10
            Dim move_args As New MouseEventArgs( _
                Windows.Forms.MouseButtons.Left, _
                0, _
                CInt(cx + radius * Cos(angle) + rnd.Next(-20, 20)), _
                CInt(cy + radius * Sin(angle) + rnd.Next(-20, 20)), _
                0)
            Me.OnMouseMove(move_args)
        Next angle

        ' Connect back to the first point.
        Me.OnMouseMove(down_args)

        ' MouseUp.
        Me.OnMouseUp(down_args)
    End Sub
End Class
