Public Class Form1
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        ' Print.
        pdocForm.Print()
    End Sub

    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        ' Display the print preview.
        pviewForm.Document = pdocForm
        pviewForm.ShowDialog()
    End Sub

    ' Print the form's image.
    Private Sub pdocForm_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocForm.PrintPage
        ' Get an image of the form.
        Dim bm As Bitmap = GetFormImage(Me, cboIncludeBorders.Checked)

        ' Prepare the Graphics object.
        PrepareGraphics(e, bm)

        ' Draw the image at the origin.
        e.Graphics.DrawImage(bm, 0, 0, bm.Width, bm.Height)

        ' There's only one page.
        e.HasMorePages = False

        ' Set to True to draw the margin and a box around the image.
#Const DEBUGGING = False
#If DEBUGGING Then
        e.Graphics.ResetTransform()
        e.Graphics.DrawRectangle(Pens.Blue, e.MarginBounds)
#End If
    End Sub

    ' Scale and translate the Graphics object appropriately.
    Private Sub PrepareGraphics(ByVal e As System.Drawing.Printing.PrintPageEventArgs, ByVal bm As Bitmap)
        ' See how big the resulting image should be.
        Dim the_scale As Single
        If cboFitPage.Checked Then
            ' Scale to fit.
            Dim aspect1 As Double = bm.Width / bm.Height
            Dim aspect2 As Double = e.MarginBounds.Width / e.MarginBounds.Height
            If aspect1 > aspect2 Then
                ' The image is relatively wider and thinner than the page.
                ' Make it fit the page's width.
                the_scale = CSng(e.MarginBounds.Width / bm.Width)
            Else
                ' The image is relatively shorter and taller than the page.
                ' Make it fit the page's height.
                the_scale = CSng(e.MarginBounds.Height / bm.Height)
            End If

            ' Scale.
            e.Graphics.ScaleTransform(the_scale, the_scale)
        Else
            ' Use the image at its normal scale.
            the_scale = 1
        End If

        ' Translate to center the image.
        Dim wid As Single = bm.Width * the_scale
        Dim hgt As Single = bm.Height * the_scale
        Dim dx As Single = e.MarginBounds.X + (e.MarginBounds.Width - wid) / 2
        Dim dy As Single = e.MarginBounds.Y + (e.MarginBounds.Height - hgt) / 2
        e.Graphics.TranslateTransform(dx, dy, Drawing2D.MatrixOrder.Append)

#If DEBUGGING Then
        e.Graphics.DrawRectangle(Pens.Red, -5, -5, m_FormBitmap.Width + 10, m_FormBitmap.Height + 10)
#End If
    End Sub

    ' Set landscape or portrait orientation.
    Private Sub pdocForm_QueryPageSettings(ByVal sender As Object, ByVal e As System.Drawing.Printing.QueryPageSettingsEventArgs) Handles pdocForm.QueryPageSettings
        If cboLandscape.Checked Then
            ' Print in landscape.
            e.PageSettings.Landscape = True
        Else
            ' Print in portrait.
            e.PageSettings.Landscape = False
        End If
    End Sub
End Class
