Module PrintFormCode
    ' Return the form's image.
    Public Function GetFormImage(ByVal frm As Form, ByVal include_borders As Boolean) As Bitmap
        ' Get the whole form.
        Dim wid, hgt As Integer
        wid = frm.Width
        hgt = frm.Height
        Dim bm As Bitmap = New Bitmap(wid, hgt)
        frm.DrawToBitmap(bm, New Rectangle(0, 0, wid, hgt))

        ' If we want the borders, return this bitmap.
        If include_borders Then Return bm

        ' Make a new bitmap to hold the image without the borders.
        Dim new_wid As Integer = frm.ClientSize.Width
        Dim new_hgt As Integer = frm.ClientSize.Height
        Dim new_bm As New Bitmap(new_wid, new_hgt)
        Dim new_gr As Graphics = Graphics.FromImage(new_bm)

        ' Get the client area's origin in screen coordinates.
        Dim origin As New Point(0, 0)
        origin = frm.PointToScreen(origin)

        ' See how far this is from the form's upper left corner.
        Dim x As Integer = origin.X - frm.Left
        Dim y As Integer = origin.Y - frm.Top

        ' Copy the form's client area image into the new bitmap.
        new_gr.DrawImage(bm, _
            New RectangleF(0, 0, new_wid, new_hgt), _
            New RectangleF(x, y, new_wid, new_hgt), _
            GraphicsUnit.Pixel)

        ' Return the client area image.
        Return new_bm
    End Function
End Module
