Imports System.IO
Imports System.Reflection
Imports System.Resources

Public Class Form1
    ' The assembly's information.
    Private m_Assembly As [Assembly] = Nothing

    ' Type objects for the assembly's resources.
    Private m_Resources As Type = Nothing

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim file_info As New FileInfo(Application.StartupPath & _
            "..\..\..\..\ResourcesLib\bin\Debug\ResourcesLib.dll")

        txtPath.Text = file_info.FullName
        txtFile.Location = panImage.Location
        txtFile.Size = panImage.Size
    End Sub

    ' Get information about the assembly's resources.
    Private Sub btnGetResourceInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetResourceInfo.Click
        ' Get the assembly's information.
        m_Assembly = [Assembly].LoadFrom(txtPath.Text)

        ' Clear results.
        lstResources.Items.Clear()

        ' List the resource names.
        Dim resource_names() As String = m_Assembly.GetManifestResourceNames()
        For Each resource_name As String In resource_names
            ' Skip the resource manifest itself.
            If Not resource_name.EndsWith(".Resources.resources") Then
                lstResources.Items.Add(resource_name)
            End If
        Next resource_name
    End Sub

    ' Display the selected resource.
    Private Sub lstResources_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstResources.SelectedIndexChanged
        panImage.Visible = False
        txtFile.Visible = False

        Dim resource_name As String = lstResources.SelectedItem.ToString
        Dim extension As String = resource_name.Substring(resource_name.LastIndexOf("."))
        Select Case extension
            Case ".bmp", ".gif", ".jpg", ".jpeg"
                Dim bm As New Bitmap( _
                    m_Assembly.GetManifestResourceStream(resource_name))
                picImage.Image = bm
                panImage.Visible = True
            Case ".txt"
                Using stream_reader As New StreamReader(m_Assembly.GetManifestResourceStream(resource_name))
                    txtFile.Text = stream_reader.ReadToEnd()
                    stream_reader.Close()
                End Using
                txtFile.Visible = True
            Case ".wav"
                Using stream_reader As New StreamReader(m_Assembly.GetManifestResourceStream(resource_name))
                    My.Computer.Audio.Play(stream_reader.BaseStream, AudioPlayMode.WaitToComplete)
                    stream_reader.Close()
                End Using
            Case Else
                MessageBox.Show("Unknown resource type", _
                    "Unknown Resource Type", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Exclamation)
        End Select
    End Sub

    ' Let the user browse for an assembly.
    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        If dlgSelectAssembly.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            txtPath.Text = dlgSelectAssembly.FileName
        End If
    End Sub
End Class
