Imports System.Reflection
Imports System.Collections.Generic
Imports System.Drawing

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const SAMPLE_WID As Integer = 120
    Private Const SAMPLE_HGT As Integer = 30
    Private Const X_MARGIN As Integer = 10
    Private Const Y_MARGIN As Integer = 20
    
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Enumerate the named colors.
        Dim color_type As Type = GetType(Color)
        Dim property_infos() As PropertyInfo = color_type.GetProperties()

        ' Make a bitmap big enough to hold all of the samples.
        Const NUM_COLS As Integer = 6
        Dim num_rows As Integer = (property_infos.Length \ NUM_COLS)
        If NUM_COLS * num_rows < property_infos.Length Then num_rows += 1
        Dim wid As Integer = 2 * XMIN + NUM_COLS * SAMPLE_WID + (NUM_COLS - 1) * X_MARGIN
        Dim hgt As Integer = 3 * XMIN + num_rows * SAMPLE_HGT + (num_rows - 1) * Y_MARGIN
        Dim bm As New Bitmap( wid,hgt)
        Dim gr As Graphics = Graphics.FromImage(bm)
        gr.Clear(Me.BackColor)

        ' Draw the samples.
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN
        For Each property_info As PropertyInfo In property_infos
            ' See if this is a static (Shared) property.
            ' We only want the Shared properties such as AliceBlue
            ' and not the instance properties such as R, G, and B.
            If property_info.GetGetMethod().IsStatic Then
                ' Draw this sample.
                Dim color_obj As Object = property_info.GetValue(Nothing, Nothing)
                Dim the_color As Color = DirectCast(color_obj, Color)
                DrawSample(gr, x, y, wid, the_color, property_info.Name)
            End If
        Next property_info

        picSamples.Image = bm
        gr.Dispose()
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawSample(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal wid As Integer, ByVal the_color As Color, ByVal color_name As String)
        ' Draw the sample.
        Using br As New SolidBrush(the_color)
            gr.FillRectangle(br, x, y, SAMPLE_WID, SAMPLE_HGT)
        End Using
        gr.DrawRectangle(Pens.Red, x, y, SAMPLE_WID, SAMPLE_HGT)

        ' Draw the color's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Near
        gr.DrawString(color_name, Me.Font, Brushes.Blue, _
            x + SAMPLE_WID \ 2, y + SAMPLE_HGT, string_format)

        ' Update x and y.
        x += SAMPLE_WID + X_MARGIN
        If x + SAMPLE_WID > wid Then
            x = XMIN
            y += SAMPLE_HGT + Y_MARGIN
        End If
    End Sub
End Class
