Imports System.Collections.Generic

Public Class Form1
    Private m_Ellipses As List(Of Ellipse)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Randomize()
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()

        Dim rand As New Random
        m_Ellipses = New List(Of Ellipse)
        For i As Integer = 1 To 100
            m_Ellipses.Add(New Ellipse(rand))
        Next i

        Me.Invalidate()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        For Each ell As Ellipse In m_Ellipses
            ell.Draw(e.Graphics)
        Next ell
    End Sub

    Private Sub btnCollect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCollect.Click
        GC.Collect(0)
        Debug.WriteLine(GC.GetGeneration(m_Ellipses(0)))
        Debug.WriteLine(GC.GetTotalMemory(False))
    End Sub
End Class

Public Class Ellipse
    Public PenR As Integer
    Public PenG As Integer
    Public PenB As Integer
    Public PenWidth As Integer
    Public BrushR As Integer
    Public BrushG As Integer
    Public BrushB As Integer
    Public MyRectangle As Rectangle

    Public Sub New(ByVal rand As Random)
        PenR = rand.Next(0, 128)
        PenG = rand.Next(0, 255)
        PenB = rand.Next(128, 255)
        PenWidth = rand.Next(1, 5)

        BrushR = rand.Next(0, 128)
        BrushG = rand.Next(0, 255)
        BrushB = rand.Next(128, 255)

        MyRectangle = New Rectangle()
        With MyRectangle
            .Width = rand.Next(0, 200)
            .Height = rand.Next(0, 200)
            .X = rand.Next(0, 400) - .Width \ 2
            .Y = rand.Next(0, 400) - .Height \ 2
        End With
    End Sub

    Public Sub Draw(ByVal gr As Graphics)
        Using the_brush As New SolidBrush(Color.FromArgb(128, BrushR, BrushG, BrushB))
            gr.FillEllipse(the_brush, MyRectangle)
        End Using

        Using the_pen As New Pen(Color.FromArgb(255, PenR, PenG, PenB), PenWidth)
            gr.DrawEllipse(the_pen, MyRectangle)
        End Using
    End Sub
End Class