Imports System.Collections.Generic

Public Class Form1
    Private m_WeakReferences As New List(Of WeakReference)

    ' Allocate a new object.
    Private Sub btnAllocate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAllocate.Click
        ' Make the new Big object.
        Dim new_big As New Big(m_WeakReferences.Count + 1)

        ' Associate it with a WeakReference object.
        Dim weak_reference As New WeakReference(new_big)
        m_WeakReferences.Add(weak_reference)

        ' Display information about the active objects.
        lstObjects.Items.Clear()
        For Each wr As WeakReference In m_WeakReferences
            If wr.IsAlive Then
                Dim the_big As Big = _
                    DirectCast(wr.Target, Big)
                lstObjects.Items.Add("Generation " & GC.GetGeneration(the_big) & ", Object " & the_big.Name)
            Else
                lstObjects.Items.Add("<Dead object>")
            End If
        Next wr

        Debug.WriteLine("Memory Allocated: " & GC.GetTotalMemory(False))
    End Sub
End Class

' A Big object occupies about 256 KB.
Public Class Big
    Private Const KB256 As Integer = 1024 * 256
    Private Values(KB256) As Byte
    Public Name As Integer

    Public Sub New(ByVal new_Name As Integer)
        Name = new_Name
        Debug.WriteLine("Created " & Name)
    End Sub

    Protected Overrides Sub Finalize()
        Debug.WriteLine("Destroyed " & Name)
    End Sub
End Class